<?php
/*
Copyright 2011 da UFRGS - Universidade Federal do Rio Grande do Sul

Este arquivo  parte do programa SAELE - Sistema Aberto de Eleies Eletrnicas.

O SAELE  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos
termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre
(FSF); na verso 2 da Licena.

Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA;
sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR.
Veja a Licena Pblica Geral GNU/GPL em portugus para maiores detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt",
junto com este programa, se no, acesse o Portal do Software Pblico Brasileiro no
endereo www.softwarepublico.gov.br ou escreva para a Fundao do Software Livre(FSF)
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
*/

final class Candidato extends Entidade {
    protected $NomeTabela = "eleicoes.candidato";
    protected $VetorChaves = array(
      "codconcurso"     => array(Tipo => numero, Tamanho => 4, Foreign => true, Classe => "ConcursoEleitoral"),
      "codeleicao"      => array(Tipo => numero, Tamanho => 4, Foreign => true, Classe => "Eleicao"),
      "codchapa"        => array(Tipo => numero, Tamanho => 4, Foreign => true, Classe => "Chapa"),
      "codpessoaeleicao"=> array(Tipo => numero, Tamanho => 8, Foreign => true, Classe => "PessoaEleicao")
    );
    protected $VetorCampos = array(
      "codparticipacao" => array(Nome => "Participao", Tipo => numero, Tamanho => 2, Obrigatorio => true, Classe => "Participacao")
    );

    protected $ClassesAnexadas = array(
        "PessoaEleicao" => array(
            "Tabela" => "eleicoes.pessoaeleicao",
            "Chaves" => array("codpessoaeleicao" => "codpessoaeleicao"),
            "Inner" => true),
        "Participacao" => array(
            "Tabela" => "eleicoes.participacao",
            "Chaves" => array("codparticipacao" => "codparticipacao"),
            "Inner" => true)
    );

    private $Concurso, $Eleicao, $Chapa, $Pessoa;

    public function __construct($Arg1, $Arg2=null, $Arg3=null, $Arg4=null) {
        parent::__construct($Arg1, $Arg2, $Arg3, $Arg4);
        if($Arg1 instanceof ConcursoEleitoral) {
            $this->Concurso = $Arg1;
            $this->Eleicao = $Arg2;
            $this->Chapa = $Arg3;
            $this->Pessoa = $Arg4;
        }
    }

    public function salva() {
        if($this->novo()) {
            if($this->Eleicao->verificaComissao($this->Pessoa) !== false)
                throw new CandidatoException("Esta pessoa faz parte da Comisso Eleitoral", 1);
            if($this->Eleicao->devolveCandidato($this->Pessoa) !== null)
                throw new CandidatoException("Esta pessoa j  candidato desta Eleio", 2);
        }
        parent::salva();
    }
}

class CandidatoException extends Exception {
    
}
?>