<?php
/*
Copyright 2011 da UFRGS - Universidade Federal do Rio Grande do Sul

Este arquivo  parte do programa SAELE - Sistema Aberto de Eleies Eletrnicas.

O SAELE  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos
termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre
(FSF); na verso 2 da Licena.

Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA;
sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR.
Veja a Licena Pblica Geral GNU/GPL em portugus para maiores detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt",
junto com este programa, se no, acesse o Portal do Software Pblico Brasileiro no
endereo www.softwarepublico.gov.br ou escreva para a Fundao do Software Livre(FSF)
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
*/

require_once("Entidade.class.php");

class Iterador implements Iterator, Countable {
  private $NotEOF = false;
  private $TemRegistro;
  private $Consulta = NULL;
  private $NomeClasse = NULL;
  private $Objeto = NULL;
  private $VarsExtra = NULL;

  public function __construct($NomeClasse, $SQLAdicional=NULL, $ParametrosAdicionais=array(), $VarsExtra=NULL) {
    $this->NomeClasse = $NomeClasse;
    $dummy = new $NomeClasse("dummy");
    $Consulta = $dummy->devolveConsultaIterador();
    $Consulta->addSQL(" ".$SQLAdicional);
    $Consulta->setParametros(todos, $ParametrosAdicionais);

    $this->Consulta = $Consulta;
    $this->VarsExtra = $VarsExtra;
    $this->NotEOF = ($this->Consulta->executa(true));
    if($this->NotEOF) {
      $this->TemRegistro = true;
      $this->Objeto = new $this->NomeClasse($this->Consulta, $this->VarsExtra);
    }
    else
      $this->TemRegistro = false;
  }
  
  function proximo() {
    $Objeto = $this->Objeto;
    $this->next();
    return $Objeto;
  }
  
  function devolveVetor() {
    $VetorRetorno = array();
    if($this->NotEOF) {
      do {
        $VetorRetorno[$this->Objeto->getChave()] = $this->Objeto->getAll();
        $this->next();
      } while($this->NotEOF);
      $this->rewind();
    }
    return $VetorRetorno;
  }
  
  function temRegistro() {
    return $this->TemRegistro;
  }
  
  function rewind() {
    if($this->TemRegistro) {
      $this->NotEOF = $this->Consulta->primeiro();
      $this->Objeto = new $this->NomeClasse($this->Consulta, $this->VarsExtra);
    }
  }
  
  function current() {
    return $this->Objeto;
  }
  
  function key() {
    if(is_null($this->Objeto))
      return 0;
    
    return $this->Objeto->getChave();
  }
  
  function next() {
    $this->NotEOF = ($this->Consulta->proximo());
    if($this->NotEOF)
      $this->Objeto = new $this->NomeClasse($this->Consulta, $this->VarsExtra);
  }
  
  function valid() {
    return $this->NotEOF;
  }
  
  function count() {
    return $this->Consulta->nrlinhas();
  }
}