<?php
/*
Copyright 2011 da UFRGS - Universidade Federal do Rio Grande do Sul

Este arquivo  parte do programa SAELE - Sistema Aberto de Eleies Eletrnicas.

O SAELE  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos
termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre
(FSF); na verso 2 da Licena.

Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA;
sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR.
Veja a Licena Pblica Geral GNU/GPL em portugus para maiores detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt",
junto com este programa, se no, acesse o Portal do Software Pblico Brasileiro no
endereo www.softwarepublico.gov.br ou escreva para a Fundao do Software Livre(FSF)
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
*/

define("DESCRICAO_ZERESIMA", "Zersima");
define("DESCRICAO_CONTAGEM", "Contagem de votos");
define("DESCRICAO_RECONTAGEM", "Recontagem de votos");
define("DESCRICAO_FINALIZACAO", "Concurso Eleitoral finalizado");
define("DESCRICAO_ACESSOVOTACAO", "Acesso  rea de votao");
define("DESCRICAO_INICIOVOTO", "Consistncia OK, incio da operao de voto");
define("DESCRICAO_VOTOEFETUADO", "Voto efetuado com sucesso");
define("DESCRICAO_EMAILS", "E-Mails enviados");

class LogOperacao extends Entidade {
    protected $NomeTabela = "eleicoes.logoperacao";
    protected $VetorChaves = array(
      "codconcurso"         => array(Tipo => numero, Tamanho => 4, Foreign => true, Classe => "ConcursoEleitoral"),
      "nrseqlogoperacao"    => array(Tipo => numero, Tamanho => 8, Foreign => false)
    );
    protected $VetorCampos = array(
      "codeleicao"          => array(Nome => "Eleio", Tipo => numero, Tamanho => 4, Obrigatorio => false, Classe => "Eleicao"),
      "codpessoaeleicao"    => array(Nome => "Pessoa", Tipo => numero, Tamanho => 8, Obrigatorio => false, Classe => "PessoaEleicao"),
      "dataoperacao"        => array(Nome => "Data de Operao", Tipo => datahora, Obrigatorio => true),
      "ip"                  => array(Nome => "IP", Tipo => texto, Tamanho => 15, Obrigatorio => true),
      "descricao"           => array(Nome => "Descrio", Tipo => texto, Tamanho => 120, Obrigatorio => true)
    );

    public static function getNumLogsPorDescricao($Descricao, ConcursoEleitoral $Concurso, Eleicao $Eleicao=null) {
        $SQL = " select count(*) as Num from eleicoes.logoperacao
                 where codconcurso = :CodConcurso[numero]
                   and descricao = :Descricao[texto] ";
        $Consulta = new consulta($SQL);
        $Consulta->setParametros("CodConcurso", $Concurso->getChave());
        $Consulta->setParametros("Descricao", $Descricao);
        if(is_null($Eleicao))
            $Consulta->addSQL("and codeleicao is null");
        else {
            $Consulta->addSQL("and codeleicao = :CodEleicao[numero] ");
            $Consulta->setParametros("CodEleicao", $Eleicao->getChave());
        }
        $Consulta->executa(true);
        return (int)$Consulta->campo("Num");
    }

    public static function getLogPorDescricao($Descricao, ConcursoEleitoral $Concurso, Eleicao $Eleicao=null) {
        $SQL = " select * from eleicoes.logoperacao
                 where codconcurso = :CodConcurso[numero]
                   and descricao = :Descricao[texto] ";
        $Consulta = new consulta($SQL);
        $Consulta->setParametros("CodConcurso", $Concurso->getChave());
        $Consulta->setParametros("Descricao", $Descricao);
        if(is_null($Eleicao))
            $Consulta->addSQL("and codeleicao is null");
        else {
            $Consulta->addSQL("and codeleicao = :CodEleicao[numero] ");
            $Consulta->setParametros("CodEleicao", $Eleicao->getChave());
        }
        if($Consulta->executa(true))
            return new LogOperacao($Consulta);
        else
            return null;
    }

    public static function getIteradorLogsPorDescricao($Descricao, ConcursoEleitoral $Concurso, Eleicao $Eleicao=null) {
        $SQL = " where codconcurso = :CodConcurso[numero]
                   and descricao = :Descricao[texto] ";
        if(is_null($Eleicao)) {
            $SQL .= " and codeleicao is null ";
            $CodEleicao = NULL;
        }
        else {
            $SQL .= "and codeleicao = :CodEleicao[numero] ";
            $CodEleicao = $Eleicao->getChave();
        }
        return new Iterador("LogOperacao", $SQL, array("CodConcurso" => $Concurso->getChave(), "CodEleicao" => $CodEleicao, "Descricao" => $Descricao));
    }
}
?>
