<?php
/*
Copyright 2011 da UFRGS - Universidade Federal do Rio Grande do Sul

Este arquivo  parte do programa SAELE - Sistema Aberto de Eleies Eletrnicas.

O SAELE  um software livre; voc pode redistribu-lo e/ou modific-lo dentro dos
termos da Licena Pblica Geral GNU como publicada pela Fundao do Software Livre
(FSF); na verso 2 da Licena.

Este programa  distribudo na esperana que possa ser til, mas SEM NENHUMA GARANTIA;
sem uma garantia implcita de ADEQUAO a qualquer MERCADO ou APLICAO EM PARTICULAR.
Veja a Licena Pblica Geral GNU/GPL em portugus para maiores detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo "LICENCA.txt",
junto com este programa, se no, acesse o Portal do Software Pblico Brasileiro no
endereo www.softwarepublico.gov.br ou escreva para a Fundao do Software Livre(FSF)
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
*/

/**
 * Esta classe representa um membro da comisso eleitoral de uma eleio.
 * Alm de um membro comum, uma pessoa pode ser gerente da eleio, e essa distino
 *  indicada pela coluna "gerente".
 */
final class MembroComissao extends Entidade {
    protected $NomeTabela = "eleicoes.comissaoeleitoral";
    protected $VetorChaves = array(
      "codconcurso"     => array(Tipo => numero, Tamanho => 4, Foreign => true, Classe => "ConcursoEleitoral"),
      "codeleicao"      => array(Tipo => numero, Tamanho => 4, Foreign => true, Classe => "Eleicao"),
      "codpessoaeleicao"=> array(Tipo => numero, Tamanho => 8, Foreign => true, Classe => "PessoaEleicao")
    );
    protected $VetorCampos = array(
      "gerente"     => array(Nome => "Gerente", Tipo => texto, Tamanho => 1, Obrigatorio => true, Valores => array("S", "N"))
    );

    protected $ClassesAnexadas = array(
        "PessoaEleicao" => array(
            "Tabela" => "eleicoes.pessoaeleicao",
            "Chaves" => array("codpessoaeleicao" => "codpessoaeleicao"),
            "Inner" => true)
    );

    private $Concurso, $Eleicao, $Pessoa;

    public function __construct($Arg1, $Arg2=null, $Arg3=null) {
        parent::__construct($Arg1, $Arg2, $Arg3);
        if($Arg1 instanceof ConcursoEleitoral) {
            $this->Concurso = $Arg1;
            $this->Eleicao = $Arg2;
            $this->Pessoa = $Arg3;
        }
    }

    public function salva() {
        if($this->novo()) {
            if($this->Eleicao->devolveCandidato($this->Pessoa) !== null)
                throw new MembroComissaoException("Esta pessoa  candidato desta Eleio", 2);
        }
        parent::salva();
    }
}

class MembroComissaoException extends Exception {
    
}
?>